#!/bin/sh

acs_is_ssu=0

# this sesstion is auto-generated by KB_manage system
# ---- start ----
acs_dev_archive_number="KB-AF-20220411-SvpnEnableSavePwd"
acs_package_seq="AF8023-8048"

acs_version_list="AF8.0.48EN AF8.0.48B AF8.0.48 AF8.0.47EN AF8.0.47 AF8.0.46EN AF8.0.46 AF8.0.45EN AF8.0.45 AF8.0.42EN AF8.0.42 AF8.0.39 AF8.0.35R1 AF8.0.35B AF8.0.35EN AF8.0.35 AF8.0.34B AF8.0.32R1EN AF8.0.32R1 AF8.0.32EN AF8.0.32 AF8.0.30EN AF8.0.30 AF8.0.28EN AF8.0.28 AF8.0.26EN AF8.0.26B AF8.0.26 AF8.0.23R3 AF8.0.23EN AF8.0.23 AF8.0.39EN"
acs_machine_list=""
acs_machine_except_list=""
acs_machine_reboot=0

# delete procedure
delete_procedure() {
	return 0
}
# prerun function
acs_function_before_unpack() {
qdbconf /fwlog/sslvpn/config/etc/db/sysconf/sysconf.db -d  Advanced.EnableSavePwd
qdbconf /fwlog/sslvpn/config/config_af/config/etc/db/sysconf/sysconf.db -d  Advanced.EnableSavePwd
qdbconf /fwlog/sslvpn/sftmpfs/etc/db/sysconf/sysconf.db -d  Advanced.EnableSavePwd

qdbconf /fwlog/sslvpn/config/etc/db/sysconf/sysconf.db -i  Advanced.EnableSavePwd 1
qdbconf /fwlog/sslvpn/config/config_af/config/etc/db/sysconf/sysconf.db -i  Advanced.EnableSavePwd 1
qdbconf /fwlog/sslvpn/sftmpfs/etc/db/sysconf/sysconf.db -i  Advanced.EnableSavePwd 1

qdbconf /fwlog/sslvpn/config/etc/db/sysconf/sysconf.db -d  Advanced.EnableAutoLogin
qdbconf /fwlog/sslvpn/config/config_af/config/etc/db/sysconf/sysconf.db -d  Advanced.EnableAutoLogin
qdbconf /fwlog/sslvpn/sftmpfs/etc/db/sysconf/sysconf.db -d  Advanced.EnableAutoLogin

qdbconf /fwlog/sslvpn/config/etc/db/sysconf/sysconf.db -i  Advanced.EnableAutoLogin 1
qdbconf /fwlog/sslvpn/config/config_af/config/etc/db/sysconf/sysconf.db -i  Advanced.EnableAutoLogin 1
qdbconf /fwlog/sslvpn/sftmpfs/etc/db/sysconf/sysconf.db -i  Advanced.EnableAutoLogin 1

/etc/init.d/svpnall restart

	delete_procedure
	return 0
}
# postrun function
acs_function_after_unpack() {

	return 0
}
# ---- end ----

#用来在changelog文件中记录研发对应的归档号
# acs_dev_archive_number="KB-AC-xxxxxxxx-xxx" #必填项
# acs_package_seq="xx" #这里填写包的序号，比如 01，02，03等等

#acs_is_ssu=0
#acs_whoiam=""
#acs_td_number=""

acs_update_log="/var/upd_sh_err.log"
acs_echo()
{
	echo $1
	echo $1 >> ${acs_update_log}
}
#8.0.2改了组建双机的条件，appversion的当前打包时间要更改，因此把信息重定向到另一个文件跟踪记录
new_appversion_file="/fwlog/new_appversion"
acs_appversion="/app/appversion"
acs_appversion_bak_cn="/version/appversion"
acs_appversion_bak_en="/version/appversion_en"

check_syncd()
{
	local HA_CFG_PATH=/etc/sinfor/fw/ha.ini
	local enable_sync=$(rwini -s sync -k enable -f ${HA_CFG_PATH})
	if [ $enable_sync -eq 1 ]; then
		/etc/init.d/syncd restart
	fi
}

acs_chg_appversion()
{
        #把当前打包时间信息以及其他因素一律有干扰的裁掉回写到/app/appversion，只保留KB归档号就可以了
        
        echo "custom-build support information " >> "${1}"
        echo "support-build support ${acs_dev_archive_number}" >> "${1}"
        
}

acs_chg_other_version_file()
{
	#把之前的信息重定向到非/app/appversion的文件中跟踪
	echo "custom-build ${acs_update_time} support information " >> "${1}"
    echo "support-build ${acs_depart} support ${acs_whoiam} ${acs_update_time} ${acs_sequence} ${acs_td_number} ${acs_dev_archive_number}" >> "${1}"
}

#版本检测，版本检测列表不能为空，必须限定版本
acs_version_check_ok()
{
	acs_main_ver_number=$(head -n 1 ${acs_appversion} | awk '{print NF}')
	acs_main_ver=$(head -n 1 ${acs_appversion} | awk '{print $1}')
	acs_r_ver=$(head -n 1 ${acs_appversion} | awk '{if (NF >= 3) print $2}')
	acs_sp_ver=$(head -n 1 ${acs_appversion} | awk '{if (NF >= 4) print $3}')
	
	acs_main_ver=${acs_main_ver%.*}
	
	if [ "${acs_main_ver_number}" -lt "2" ]; then
		acs_echo "The ${acs_appversion} was damaged. update failed, please looking for developer!"
		return 1
	fi
	
	echo "${acs_main_ver}" | grep -e "AF" > /dev/null 2>&1
	if [ $? -ne 0 ] ; then
		acs_echo "This machine is not an AF. update failed!"
		return 1
	fi

	if [ "${acs_version_list}" == "" ];then
		acs_echo "must set version support list, update failed"
		return 1
	fi

	acs_whole_ver="${acs_main_ver}${acs_r_ver}${acs_sp_ver}"
	
	for acs_ver in ${acs_version_list}
	do
		if [ "${acs_ver}" == "${acs_whole_ver}" ];then
			acs_echo "version check ok"
			return 0
		fi
	done
	acs_echo "This package supported version list is ${acs_version_list}."
	acs_echo "This machine's version is $(head -n 1 ${acs_appversion})."
	acs_echo "version check failed, update failed."
	return 1
}
#升级时间
acs_update_time=`date +%Y%m%d-%H%M%S`
#压缩包名字，在压缩包里面的文件，将自动备份，不需要再手动干预，格式为 tar -zcvf打包的文件
#打包时必须是按设备上的全路径打包，而且要注意添加权限，用户属性等等
if [ ! -f "/usr/sbin/dirname" ] && [ ! -f "/sbin/dirname" ] && [ ! -f "/usr/bin/dirname" ] && [ ! -f "/bin/dirname" ];then
	alias dirname="busybox dirname"
fi
acs_package_path=`dirname $0`
if [ ${acs_is_ssu} -eq 1 ];then
	#acs_package="${acs_package_path}/app1"
	acs_version_check_ok
	if [ $? -ne 0 ];then
		acs_echo "acs_version_check faild,update faild"
		exit -1
	fi
	acs_package="/stmp/app"
	acs_function_before_unpack
	tar -Pxzf "$acs_package" -C /
	acs_chg_appversion "${acs_appversion}"
	acs_chg_appversion "${acs_appversion_bak_cn}"
	acs_chg_appversion "${acs_appversion_bak_en}"
	acs_chg_other_version_file "${new_appversion_file}"
	acs_function_after_unpack
	check_syncd
	sync
	mount -o remount,ro /dev/root /
	mount -o remount,ro /dev/sda1 /boot/
	exit 0
else
	acs_package="${acs_package_path}/${acs_dev_archive_number}_package-${acs_package_seq}.tgz" #ûÿÿtar.gzÿÿÿɲÿÿÿ
fi

#本网上问题修正包支持版本，必须是下列排列中的一个或多个
# for example acs_version_list="AF2.2 AF2.2R1 AF2.2R1SP1 AF2.2R1SP2 AF2.2R1SP3"
# acs_version_list="AF1.0 AF1.0R1 AF1.0R2 AF1.1 AF2.0 AF2.0SP1 AF2.0R1 AF2.1 AF2.2 AF2.2R1 AF2.2R1SP1 AF2.2R1SP2 AF2.2R1SP3"
# acs_version_list="AF2.6SP1 AF2.6R1 AF2.6R1SP1 AF3.0 AF3.0SP1 AF3.0SP2 AF3.0SP3 AF4.0 AF4.1 AF4.3 AF4.5"
# acs_version_list=""

#执行完后是否需要重启，需要为1 ，不需要为0
# acs_machine_reboot=0



#下面两个function函数，用来做自定义操作
#除在开头定义的几个变量外，还可以引用的已知公共变量有
# acs_sequence 技术支持备份序号
# acs_depart 技术支持部门
# acs_whoiam 支持支持人员
# acs_backup_dir  = /app/home/${acs_depart}-support/${acs_sequence}/bak 技术支持备份文件目录
# acs_backup_top = /app/home/${acs_depart}-support/${acs_sequence} 技术支持备份根目录
# acs_chglog_patch = /app/home/${acs_depart}-support/changelog.txt 技术支持修改记录说明文件
# 
#可以使用的公共函数有
# acs_chg_add_file 创建一个新文件时使用，总共1个参数，参数是新加文件的原始全路径
# acs_chg_modify_file 替换/修改一个文件时使用，总共1个参数，参数是修改文件的原始全路径
# acs_chg_delete_file 删除一个文件时使用，总共1个参数，参数是被删除文件的原始全路径
#如果不是在压缩包里面替换文件，而是选择在这两个自定义函数中替换，则必须做相应操作时，执行上述3个函数
#否则不会进行备份处理
#for example：
#删除一个文件
# acs_chg_delete_file "/lib/modules/e1000.o-NONAPI"
# mv /lib/modules/e1000.o-NONAPI ${acs_backup_dir}
#添加一个文件
# acs_chg_add_file "/app/home/self.txt"
# touch /app/home/self.txt
#修改一个文件
# acs_chg_modify_file "/etc/sinfor/ddd"
# echo "hello" >>/etc/sinfor/ddd
#再次提醒：在压缩包acs_package里面的所有文件，不需要自行手动执行acs_chg*系列函数，可以自动添加备份

acs_delete_file()
{
	if [ -f "${1}" ];then
		acs_chg_delete_file $1
		mv $1 ${acs_backup_dir}/
	fi
}
#选择填写的函数实现，此函数会在解压tar.gz的安装包前调用，用来实现为解压数据包做一些前期准备
acs_function_self_check()
{
	#return 0 success， 1 failed
	return 0
}

#acs_function_before_unpack()
#{
#	return 0
#}

#选择填写的函数实现，此函数会在解压tar.gz的安装包后调用，用来实现为解压数据包后，做一些后续处理操作
#acs_function_after_unpack()
#{
#	return 0
#}

##############################################################################################


if [ "${acs_package}" != "" ] && [ ! -f "${acs_package}" ];then
	acs_echo "${acs_package} no exist, update failed"
	exit -1
fi

#AF需要检查跟文件系统是否是只读的
acs_is_root_readonly()
{
	acs_test_file=""
	
	while true;
	do 
		acs_random=$(head -n 1 /dev/urandom | cksum | cut -f 1 -d " ")
		acs_test_file="test_readonly_${acs_random}"
		if [ ! -e "${acs_test_file}" ]; then
			break;
		fi
	done
	
	touch ${acs_test_file} > /dev/null 2>&1
	
	#如果成功，
	if [ $? == 0 ]; then
		rm -rf ${acs_test_file} > /dev/null 2>&1
		return 1;
	fi

	#不成功则为只读文件系统，返回0
	return 0;
}



#AF只做版本检测，不做其他的检测
acs_version_check_ok
if [ $? -ne 0 ];then
	acs_echo "acs_version_check faild,update faild"
	exit -1
fi
acs_function_self_check
if [ $? -ne 0 ];then
	acs_echo "Self check failed, update failed"
	exit -1
fi


#定制技术支持检测
if grep -E "(custom|support-build)" ${acs_appversion};then
	acs_echo "It is a custom version ,Looking for R&D recognition  "
	if [ ${acs_is_ssu} -eq 1 ];then
		exit -1
	fi
	acs_echo "Are you sure ? yes/no :"
	while read acs_confirm
	do
		if [ "${acs_confirm}" != "Y" ] && [ "${acs_confirm}" != "y" ] && [ "${acs_confirm}" != "YES" ]  &&  [ "${acs_confirm}" != "yes" ];then
			acs_echo "update failed custom check failed,update failed"
			exit -1
		else
			acs_echo "confirm custom ok"
			break
		fi
	done
fi

if [ ${acs_is_ssu} -eq 1 ];then
	acs_depart="dev"
else
	#ÿÿÿÿÿÿÿڲÿÿÿ
	acs_echo "Please input your department(dev or cti):"
	while read acs_depart
	do
		if [ "${acs_depart}" != "dev" ] && [ "${acs_depart}" != "cti" ];then
			acs_echo "please input dev or cti, again"
			acs_echo "Please input your department(dev or cti):"
		else
			acs_echo "you choice ${acs_depart} now"
			break
		fi
	done
	
	#ÿÿÿÿÿÿÿÿװÿÿÿÿÿÿ
	acs_echo "Please input your name:"
	while read acs_whoiam
	do
		if [ "x${acs_whoiam}" == "x" ];then
			acs_echo "Please input your name:"
		else
			acs_echo "you input name : ${acs_whoiam}"
			break
		fi
	done
	
	#ÿÿÿÿÿÿÿÿÿÿӦÿÿTDÿÿÿÿ
	acs_echo "Please input bug TD number(for example TDxxxx, empty when no TD number):"
	read acs_td_number  
fi

#acs_sequence=`grep -c -E ${acs_depart}.*support ${acs_appversion}`
mkdir -p /app/home/${acs_depart}-support
acs_sequence=`ls -l "/app/home/${acs_depart}-support/" | grep ^d | wc -l`
acs_sequence=`expr ${acs_sequence} + 1`
if [ ${acs_sequence} -lt 10 ];then
	acs_sequence="00${acs_sequence}"
elif [ ${acs_sequence} -lt 100 ];then
		acs_sequence="0${acs_sequence}"
else
	acs_echo "this machine has too much supported,update failed!\n"
	exit -1
fi

acs_backup_top="/app/home/${acs_depart}-support/${acs_sequence}"
acs_backup_dir="${acs_backup_top}/bak"
acs_chglog_path="${acs_backup_top}/changelog.txt"

mkdir -p ${acs_backup_dir} > /dev/null 2>&1
if [ $? -ne 0 ];then
	acs_echo "can not creat backeup dirctory, update failed"
	exit -1
fi
acs_changelog_sh="/tmp/${acs_depart}_${acs_name}_${acs_sequence}.sh"
if [ -f "${acs_changelog_sh}" ];then
	rm -f ${acs_changelog_sh}
fi

echo "#! /bin/sh" >>${acs_changelog_sh}
if [ ! -f "${acs_changelog_sh}" ];then
	acs_echo "can not creat ${acs_changelog_sh}, update failed"
	exit -1
fi

echo "echo \"version ${acs_whole_ver} Looking for ${acs_dev_archive_number} (developer ori archive)\">>${acs_chglog_path}" >>${acs_changelog_sh}

acs_chg_add_file()
{
	echo "echo \"add ${1}\" >>${acs_chglog_path}" >>${acs_changelog_sh}
	echo "acs_md5_add=\`md5sum ${1}\`" >>${acs_changelog_sh}
	echo " echo \"+new: \${acs_md5_add}\">>${acs_chglog_path}">>${acs_changelog_sh}
}

acs_chg_modify_file()
{
	echo "echo \"modify ${1}\">>${acs_chglog_path}" >>${acs_changelog_sh}
	acs_delete_name=`basename ${1}`
	echo "acs_md5_del=\`md5sum ${acs_backup_dir}/${acs_delete_name}\`">>${acs_changelog_sh}
	echo "acs_md5_add=\`md5sum ${1}\`">>${acs_changelog_sh}
	echo "echo \"  -old: \${acs_md5_del}\">>${acs_chglog_path}" >>${acs_changelog_sh}
	echo "echo \"  +new: \${acs_md5_add}\">>${acs_chglog_path}" >>${acs_changelog_sh}
}

acs_chg_delete_file()
{
    echo "echo \"delete ${1}\">>${acs_chglog_path}" >>${acs_changelog_sh}
	acs_delete_name=`basename ${1}`
	echo "acs_md5_del=\`md5sum ${acs_backup_dir}/${acs_delete_name}\`">>${acs_changelog_sh}
	echo "echo \"  -old: \${acs_md5_del}\">>${acs_chglog_path}" >>${acs_changelog_sh}
}

acs_chg_create_dir()
{
	echo "echo \"create new directory :${1}\">>${acs_chglog_path}" >>${acs_changelog_sh}
}



if [ -f "${acs_package}" ];then
	acs_bak_tar_list=`tar -tzvf ${acs_package} | awk '{print $6}'`
	
	for acs_file in ${acs_bak_tar_list}; do
		if [ -e "/${acs_file}" ];then
			if [ -f "/${acs_file}" ];then
				acs_chg_modify_file "/${acs_file}"
				cp -f /${acs_file} /${acs_backup_dir}/
			fi
		else
			acs_file_is_dir=`echo "${acs_file}" | awk -F/ '{print $NF}'`
			if [ "${acs_file_is_dir}" != "" ];then
				acs_chg_add_file "/${acs_file}"
			fi
		fi
	done
fi

acs_chg_version()
{
        #此处为了解决再4.5之后的版本，appversion修改的问题
        local acs_main_ver_number=$(head -n 1 ${acs_appversion} | awk '{print NF}')
	local acs_main_ver=$(head -n 1 ${acs_appversion} | awk '{print $1}')
        
	local acs_main_ver=${acs_main_ver%.*}
	
	if [ "${acs_main_ver_number}" -lt "2" ]; then
		acs_echo "The ${acs_appversion} was damaged. update failed, please looking for developer!"
		exit -1;
	fi
	
	echo "${acs_main_ver}" | grep -e "AF" > /dev/null 2>&1
	if [ $? -ne 0 ] ; then
		acs_echo "This machine is not an AF. update failed!"
		exit -1;
	fi

	if [ "${acs_version_list}" == "" ];then
		acs_echo "must set version support list, update failed"
		exit -1
	fi

        #对于AF1.X、AF2.X、AF3.X、AF4.1、AF4.3，直接修改即可
        if [ "${acs_main_ver:0:4}" == "AF1." ] ||
           [ "${acs_main_ver:0:4}" == "AF2." ] ||
           [ "${acs_main_ver}" == "AF3.0" ] ||
           [ "${acs_main_ver}" == "AF4.1" ] ||
           [ "${acs_main_ver}" == "AF4.3" ]
        then
                acs_chg_appversion "${acs_appversion}"


        #AF4.5、4.6、4.7会有版本被修改之后，重启设备，appversion又被恢复的问题
        #这里只比对主版本进行比对
        elif [ "${acs_main_ver}" == "AF4.5" ] ||
             [ "${acs_main_ver}" == "AF4.6" ] ||
             [ "${acs_main_ver}" == "AF4.7" ]
        then
                local acs_check_language="/etc/rc2.d/S02checklanguage"

                #检查文件是否存在
                if ! [ -e "${acs_check_language}" ]
                then
                        #文件不存在        why?
                        acs_echo "Current version is ${acs_main_ver}. But ${acs_check_language} not exist."
                        acs_echo "Update failed!"
                        exit -1
                fi

                #AF4.7SP1已经解决该问题，默认会在该行添加exit，此时只需要直接修改appversion即可
                #或者已经打过补丁包，已经添加了exit
                head -n 10 "${acs_check_language}" | grep -q "exit"
                if [ "$?" -ne "0" ]
                then 
                        #添加exit，此时需要在acs_check_language文件中添加exit
                        sed -i "1a\exit 0" "${acs_check_language}"
                        if [ "$?" -ne "0" ] 
                        then
                                acs_echo "Modify ${acs_check_language} fail. Update failed"
                                exit -1
                        fi
                fi
        
                #此时再修改appversion
                acs_chg_appversion "${acs_appversion}"


        #5.0以上的版本需要同时修改/version/appversion
        else
                acs_chg_appversion "${acs_appversion}"
                acs_chg_appversion "${acs_appversion_bak_cn}"
		acs_chg_appversion "${acs_appversion_bak_en}"
		acs_chg_other_version_file "${new_appversion_file}"
        fi

}

#打包前挂载为读写，很多驻外不知道
/bin/mount -o remount,rw /root /

acs_function_before_unpack

if [ -f "${acs_package}" ];then
	tar -zxvf ${acs_package} -C /
	if [ $? -ne 0 ];then
		acs_echo "tar failed $?, update failed , please Looking for developer"
		exit -1
	fi
fi

acs_function_after_unpack

chmod +x ${acs_changelog_sh}
${acs_changelog_sh}

rm -f ${acs_changelog_sh}

#修改一下问题，在包打完之后，再修改appversion
cp -f ${acs_appversion} ${acs_backup_dir}/

acs_chg_modify_file "${acs_appversion}"
acs_chg_version
check_syncd
sync

acs_echo "update successfully"

#重新挂载为只读母盘
/bin/mount -o remount,ro /root /
if [ ${acs_machine_reboot} -ne 0 ] && [ ${acs_is_ssu} -eq 0 ];then
	acs_echo "Please confirm for reboot now: (yes/no)?"
	while read acs_machine_reboot_now
	do
		if [ "${acs_machine_reboot_now}" == "YES" ] ||  [ "${acs_machine_reboot_now}" == "yes" ];then
			for((acs_i=0;acs_i<10;acs_i++))
			do
				acs_left_time=`expr 10 - "${acs_i}"`
				acs_echo "we will reboot ${acs_left_time} second later (Ctrl+c for cancle reboot)"
				sleep 1
			done
			acs_echo "reboot now"
			reboot
		else
			if [ "${acs_machine_reboot_now}" == "NO" ] || [ "${acs_machine_reboot_now}" == "no" ];then
				acs_echo "Warring !!! please reboot later ...."
				break
			fi
		fi
	done
fi
exit 0
